]> git.pld-linux.org Git - projects/rc-scripts.git/blob - lib/functions
daemon ssd mode: keep consistent "$@"
[projects/rc-scripts.git] / lib / functions
1 #!/bin/sh - keep it for file(1) to get bourne shell script result
2 # functions     This file contains functions to be used by most or all
3 #               shell scripts in the /etc/rc.d/init.d directory.
4 #
5 #
6 # Author:       Miquel van Smoorenburg, <miquels@drinkel.nl.mugnet.org>
7 # Hacked by:    Greg Galloway and Marc Ewing
8 # Modified for PLD Linux by:
9 #               Marek Obuchowicz <elephant@pld-linux.org>
10 #               Arkadiusz Miśkiewicz <misiek@pld-linux.org>
11 #               Michał Kochanowicz <mkochano@pld-linux.org>
12 #               Łukasz Pawelczyk <havner@pld-linux.org>
13
14 # First set up a default search path.
15 export PATH="/sbin:/usr/sbin:/bin:/usr/bin"
16
17 # Set defaults
18 if [ -z "$COLUMNS" -o -z "$LINES" ]; then
19         _setterm() {
20                 set -- $(stty size 2>/dev/null)
21                 LINES=${LINES:-$1}
22                 COLUMNS=${COLUMNS:-$2}
23         }
24         _setterm
25         unset _setterm
26 fi
27 [ -z "$LINES" ] || [ "$LINES" -le 0 ] && LINES=40
28 [ -z "$COLUMNS" ] || [ "$COLUMNS" -le 0 ] && COLUMNS=80
29 export LINES COLUMNS
30 INIT_COL=$((COLUMNS - 13))
31
32 # Set colors
33 RED=1
34 GREEN=2
35 YELLOW=3
36 BLUE=4
37 MAGENTA=5
38 CYAN=6
39 WHITE=7
40 NORMAL=15
41 # Bold definition (second parameter to termput setaf)
42 BOLD=1
43 NOBOLD=0
44 # Default colors
45 CBRACKETS="$CYAN"       # brackets [ ] color
46 CDONE="$GREEN"          # DONE and WORK color
47 CBUSY="$MAGENTA"        # BUSY color
48 CFAIL="$RED"            # FAIL and DIED color
49 CPOWEREDBY="$CYAN"      # "Powered by" color
50 CPLD="$GREEN"           # "PLD Linux Distribution" color
51 CI="$RED"               # Capital I color (press I to enter interactive startup)
52 CRESMAN="$GREEN"        # "Resource Manager" color
53 CHARS=""                # Characters displayed on the beginning of show line
54 CCHARS="$NORMAL"        # Color of these characters (look at /etc/sysconfig/init-colors.gentoo example)
55
56 # save from env, set by /sbin/service
57 env_upstart=$USE_UPSTART
58
59 # Source configuration if available - may override default values
60 [ -r /etc/sysconfig/init-colors ] && . /etc/sysconfig/init-colors
61 [ -r /etc/sysconfig/system ] && . /etc/sysconfig/system
62 [ -r /etc/sysconfig/bootsplash ] && . /etc/sysconfig/bootsplash
63
64 # if initscript is invoked via bash, enable RedHat/Fedora compatibility
65 # RC_FEDORA is "set" if enabled and "unset" when not, but it's "value" is always empty
66 # this is useful for inline constructs
67 if [ "${BASH_VERSION+set}" = "set" ]; then
68         RC_LOGGING=yes
69         FASTRC=no
70         RC_FEDORA=
71 else
72         unset RC_FEDORA || :
73 fi
74
75 [ "$env_upstart" ] && USE_UPSTART=$env_upstart
76
77 if [ -z "$VSERVER" -o "$VSERVER" = "detect" ]; then
78         {
79                 while read _f _ctx; do
80                         [ "$_f" = "VxID:" -o "$_f" = "s_context:" ] && break
81                 done </proc/self/status
82         } 2>/dev/null
83         if [ -z "$_ctx" -o "$_ctx" = "0" ]; then
84                 VSERVER=no
85         else
86                 VSERVER=yes
87         fi
88         unset _f _ctx
89 fi
90
91 # VSERVER_ISOLATION_NET = isolation only inside of vserver guests
92 if [ -z "$VSERVER_ISOLATION_NET" -o "$VSERVER_ISOLATION_NET" = "detect" ]; then
93         VSERVER_ISOLATION_NET=no
94         if [ "$VSERVER" = "yes" ]; then
95                 if [ -f /proc/self/nsproxy ]; then
96                         {
97                                 while read _t _data; do
98                                         [ "$_t" = "net:" ] && break
99                                 done < /proc/self/nsproxy
100                         } 2> /dev/null
101                 else
102                         # assume old kernel mode
103                         VSERVER_ISOLATION_NET=yes
104                 fi
105                 if [ "${_data##*\(}" = "I)" ]; then
106                         VSERVER_ISOLATION_NET=yes
107                 fi
108                 unset _f _data
109         fi
110 fi
111
112 # we need to know in functions if we were called from a terminal
113 if [ -z "$ISATTY" ]; then
114         [ -t ] && ISATTY=yes || ISATTY=no
115         export ISATTY
116 fi
117
118 is_yes() {
119         # Test syntax
120         if [ $# = 0 ]; then
121                 msg_usage " is_yes {value}"
122                 return 2
123         fi
124
125         # Check value
126         case "$1" in
127         yes|Yes|YES|true|True|TRUE|on|On|ON|Y|y|1)
128                 # true returns zero
129                 return 0
130                 ;;
131         *)
132                 # false returns one
133                 return 1
134                 ;;
135         esac
136 }
137
138 is_no() {
139         # Test syntax
140         if [ $# = 0 ]; then
141                 msg_usage " is_no {value}"
142                 return 2
143         fi
144
145         case "$1" in
146         no|No|NO|false|False|FALSE|off|Off|OFF|N|n|0)
147                 # true returns zero
148                 return 0
149                 ;;
150         *)
151                 # false returns one
152                 return 1
153                 ;;
154         esac
155 }
156
157 # checks if file is empty
158 # empty lines and lines beginning with hash are ignored
159 is_empty_file() {
160         [ -s "$1" ] || return 0
161         grep -vqE "^(#|[[:blank:]]*$)" "$1" && return 1 || return 0
162 }
163
164 # returns OK if $1 contains $2
165 strstr() {
166         local a=$2
167         [ "${1#*$a*}" = "$1" ] && return 1
168         return 0
169 }
170
171 # Apply sysctl settings, including files in /etc/sysctl.d
172 apply_sysctl() {
173         if [ -x /lib/systemd/systemd-sysctl ]; then
174                 /lib/systemd/systemd-sysctl
175                 return
176         fi
177
178         local file
179         for file in /usr/lib/sysctl.d/*.conf; do
180                 [ -f /run/sysctl.d/${file##*/} ] && continue
181                 [ -f /etc/sysctl.d/${file##*/} ] && continue
182                 test -f "$file" && sysctl -q -e -p "$file"
183         done
184         for file in /run/sysctl.d/*.conf; do
185                 [ -f /etc/sysctl.d/${file##*/} ] && continue
186                 test -f "$file" && sysctl -q -e -p "$file"
187         done
188         for file in /etc/sysctl.d/*.conf; do
189                 test -f "$file" && sysctl -q -e -p "$file"
190         done
191         sysctl -q -e -p /etc/sysctl.conf
192 }
193
194 if is_yes "$FASTRC" || is_yes "$IN_SHUTDOWN"; then
195         RC_LOGGING=no
196 fi
197
198 if is_no "$RC_LOGGING"; then
199         initlog() {
200                 RESULT=0
201                 while [ "$1" != "${1##-}" ]; do
202                         case $1 in
203                         -c)
204                                 shift
205                                 $1
206                                 RESULT=$?
207                                 break
208                                 ;;
209                         *)
210                                 shift
211                                 ;;
212                         esac
213                 done
214                 return $RESULT
215         }
216 fi
217
218 kernelver() {
219         local _x _y _z v v1 old_IFS ver
220         {
221                 read _x _y v _z
222                 old_IFS=$IFS
223                 # strip _* or -* from versions like: "2.6.25_vanilla-1", "2.6.25-1"
224                 IFS='_-'
225                 set -- $v
226                 v1=${1}
227                 IFS='.'
228                 set -- $v1
229                 IFS=$old_IFS
230
231                 ver=${3}
232                 while [ ${#ver} -lt 3 ]; do ver="0$ver"; done
233                 ver="$2$ver"
234                 while [ ${#ver} -lt 6 ]; do ver="0$ver"; done
235                 ver="$1$ver"
236                 while [ ${#ver} -lt 9 ]; do ver="0$ver"; done
237                 echo $ver
238         } < /proc/version
239 }
240
241 kernelverser() {
242         local _x _y _z v v1 old_IFS ver
243         {
244                 read _x _y v _z
245                 old_IFS=$IFS
246                 # strip _* or -* from versions like: "2.6.25_vanilla-1", "2.6.25-1"
247                 IFS='_-'
248                 set -- $v
249                 v1=${1}
250                 IFS='.'
251                 set -- $v1
252                 IFS=$old_IFS
253                 ver=$2
254                 while [ ${#ver} -lt 3 ]; do ver="0$ver"; done
255                 ver="$1$ver"
256                 while [ ${#ver} -lt 6 ]; do ver="0$ver"; done
257                 echo $ver
258         } </proc/version
259 }
260
261 kernelvermser() {
262         local _x _y _z v v1 old_IFS ver
263         {
264                 read _x _y v _z
265                 old_IFS=$IFS
266                 # strip _* or -* from versions like: "2.6.25_vanilla-1", "2.6.25-1"
267                 IFS='_-'
268                 set -- $v
269                 v1=${1}
270                 IFS='.'
271                 set -- $v1
272                 IFS=$old_IFS
273                 ver="$1"
274                 while [ ${#ver} -lt 3 ]; do ver="0$ver"; done
275                 echo $ver
276         } </proc/version
277 }
278
279 # Colors workaround
280 termput() {
281         is_yes "$ISATTY" || return
282
283         if is_yes "$FASTRC" || is_no "$TPUT"; then
284                 case "$1" in
285                 hpa)
286                         echo -ne "\033[$(($2+1))G"
287                         ;;
288                 cuu*)
289                         echo -ne "\033[${2}A"
290                         ;;
291                 el)
292                         echo -ne "\033[0K"
293                         ;;
294                 setaf)
295                         local ISBOLD
296                         if [ -n "$3" ]; then
297                                 ISBOLD="$3"
298                         else
299                                 ISBOLD="$NOBOLD";
300                         fi
301                         is_yes "$COLOR_INIT" && echo -ne "\033[${ISBOLD};3${2}m"
302                         ;;
303                 op)
304                         termput setaf $NORMAL
305                         ;;
306                 esac
307         else
308                 case "$1" in
309                 hpa | cuu* | el)
310                         tput "$@"
311                         ;;
312                 setaf)
313                         if [ "$3" = "1" ]; then tput bold; else tput sgr0; fi
314                         is_yes "$COLOR_INIT" && tput setaf "$2"
315                         ;;
316                 op)
317                         termput setaf $NORMAL
318                         ;;
319                 esac
320         fi
321 }
322
323 if [ ! -x /bin/printf ]; then
324         # printf equivalent
325         # FIXME: buggy when single or double quotes in message!
326         printf() {
327                 local text m
328                 text="$1"
329                 shift
330                 if [ $# -gt 0 ]; then
331                         m="$1"
332                         shift
333                         while [ $# -gt 0 ]; do
334                                 m="$m\",\"$1"
335                                 shift
336                         done
337                 fi
338                 awk "BEGIN {printf \"$text\", \"$m\"; }"
339         }
340 fi
341
342 # National language support function
343 nls() {
344         local msg_echo nls_domain text message
345         msg_echo='\n'
346         nls_domain="$NLS_DOMAIN"
347         while [ "$1" != "${1##-}" ]; do
348                 case "$1" in
349                 --nls-domain)
350                         shift
351                         nls_domain="$1"
352                         shift
353                         ;;
354                 -n)
355                         msg_echo=''
356                         shift
357                         ;;
358                 esac
359         done
360         message="$1"
361         shift
362
363         # empty message, so we return --misiek
364         if [ -z "$message" ]; then
365                 echo -en "$msg_echo"
366                 return
367         fi
368
369         if is_yes "$GETTEXT"; then
370                 message=$(TEXTDOMAINDIR="/etc/sysconfig/locale" gettext -e --domain="${nls_domain:-rc-scripts}" "$message")
371         fi
372
373         printf "$message" "$@"
374         echo -en "$msg_echo"
375 }
376
377 rc_splash() {
378         local action="$1"
379
380         if ! is_no "$BOOT_SPLASH" && ! is_yes "$VSERVER"; then
381                 [ -x /bin/splash ] && /bin/splash "$action"
382         fi
383
384         : $((progress++))
385 }
386
387 msg_network_down() {
388         nls "ERROR: Networking is down. %s can't be run." "$1" >&2
389 }
390
391 msg_starting() {
392         show "Starting %s service" "$1"
393 }
394
395 msg_already_running() {
396         nls "%s service is already running." "$1"
397 }
398
399 msg_stopping() {
400         show "Stopping %s service" "$1"
401 }
402
403 msg_not_running() {
404         nls "%s service is not running." "$1"
405 }
406
407 msg_reloading() {
408         show "Reloading %s service" "$1"
409 }
410
411 msg_usage() {
412         nls "Usage: %s" "$*"
413 }
414
415 # Some functions to handle PLD Linux-style messages
416 show() {
417         local text len time
418
419         if is_yes "$RC_UPTIME"; then
420                 time=$(awk '{printf("[%8.2f] ", $1)}' /proc/uptime)
421         fi
422
423         if is_no "$FASTRC" && is_yes "$GETTEXT"; then
424                 text=$time$(nls -n "$@")
425         else
426                 text=$time$(printf "$@")
427         fi
428         len=${#text}
429         while [ $((len++)) -lt $INIT_COL ]; do
430                 text="$text."
431         done
432         if [ -n "$CHARS" ]; then
433                 termput setaf $CCHARS
434                 echo -n "$CHARS"
435                 termput op
436         fi
437         echo -n "$text"
438 }
439
440 deltext() {
441         termput hpa $INIT_COL
442 }
443
444 # Displays message in square brackests ("[ DONE ]"). Takes two arguments.
445 # First is the text to display, second is color number to use (argument to
446 # tput setaf). If second argument is not given, default (2, green) will be
447 # used).
448 progress() {
449         local COLOR
450         if [ -n "$2" ]; then
451                 COLOR="$2"
452         else
453                 COLOR="$CDONE"
454         fi
455         deltext
456         echo -n "$(termput setaf $CBRACKETS)[$(termput setaf $COLOR) $(nls --nls-domain rc-scripts "$1") $(termput setaf $CBRACKETS)]$(termput op)"
457 }
458
459 busy() {
460         echo -n "$_busy"
461 }
462
463 ok() {
464         echo -ne "$_ok${RC_FEDORA+\\r}${RC_FEDORA-\\n}"
465 }
466
467 started() {
468         echo "$_started"
469 }
470
471 fail() {
472         echo -ne "$_fail${RC_FEDORA+\\r}${RC_FEDORA-\\n}"
473         return 1
474 }
475
476 died() {
477         echo "$_died"
478         return 1
479 }
480
481 # Check if $pid (could be plural) are running
482 checkpid() {
483         while [ "$1" ]; do
484                 [ -d "/proc/$1" ] && return 0
485                 shift
486         done
487         return 1
488 }
489
490 # - outside chroot get only those processes, which are outside chroot.
491 # - inside chroot get only those processes, which are inside chroot.
492 # - don't filter out pids which do not have corresponding running processes (process died etc)
493 # (note: some processes like named are chrooted but run outside chroot)
494 # - do nothing inside vserver
495 filter_chroot() {
496         # filter by pid namespace if such dir exists for current process
497         # we do filter in containers as stacked containers are possible with LXC
498         if [ -d /proc/$$/ns ]; then
499                 local pids
500                 pids=$(filter_ns "$@") && set -- "$pids"
501         fi
502
503         if is_yes "$VSERVER"; then
504                 echo $@
505                 return
506         fi
507
508         if [ $# -lt 1 -o ! -d /proc/1 ]; then
509                 echo $@
510                 return
511         fi
512
513         local root_dir good_pids="" good_add_pid
514         for root_pid in $@; do
515                 root_dir=$(resolvesymlink /proc/${root_pid}/root)
516                 if [ -n "$root_dir" ]; then
517                         good_add_pid=1
518                         if [ -n "${SYSTEM_CHROOTS}" ]; then
519                                 for r_dir in ${SYSTEM_CHROOTS}; do
520                                         echo "$root_dir" | grep -q "^${r_dir}" && good_add_pid=0
521                                 done
522                         fi
523                         [ "$good_add_pid" -eq 1 ] && good_pids="$good_pids $root_pid"
524                 elif [ ! -d "/proc/$root_pid" ]; then
525                         good_pids="$good_pids $root_pid"
526                 fi
527         done
528         echo $good_pids
529 }
530
531 # similar to filter_chroot, but filter based on /proc/PID/ns/pid value
532 filter_ns() {
533         local cur_ns=$(resolvesymlink /proc/$$/ns/pid)
534         [ "$cur_ns" ] || return 1
535
536         local pid ns pids=""
537         # add pids if it matches current pid namespace
538         # we should add pids what do not exist (dead processes),
539         # but not add pids whose namespace does not match
540         # (processes belonging to different NS do exist in /proc)
541         for pid in "$@"; do
542                 if [ ! -d /proc/$pid ]; then
543                         pids="$pids $pid"
544                         continue
545                 fi
546                 ns=$(resolvesymlink /proc/$pid/ns/pid)
547                 if [ "$ns" = "$cur_ns" ]; then
548                         pids="$pids $pid"
549                 fi
550         done
551         echo $pids
552         return 0
553 }
554
555 # Usage:
556 # run_cmd Message command_to_run
557 # run_cmd -a Message command_to_run
558 # run_cmd --user "username" "Message" command_to_run
559 run_cmd() {
560         local force_err=0 exit_code=0 errors user
561         while [ $# -gt 0 ]; do
562                 case "$1" in
563                 -a)
564                         force_err=1
565                         ;;
566                 --user)
567                         shift
568                         user=$1
569                         ;;
570                 *)
571                         break
572                 esac
573                 shift
574         done
575
576         local message=$1; shift
577         show "$message"; busy
578
579         if errors=$(
580                 cd /
581                 export HOME=/tmp TMPDIR=/tmp
582                 if is_no "$RC_LOGGING"; then
583                         ${user:+setuidgid -s $user} "$@" 2>&1
584                 else
585                         ${user:+setuidgid -s $user} initlog -c "$*" 2>&1
586                 fi
587                 ); then
588                 ok
589                 log_success "$1 $message"
590         else
591                 fail
592                 log_failed "$1 $message"
593                 exit_code=1
594         fi
595         [ -n "$errors" ] && [ $exit_code -eq 1 -o $force_err -eq 1 ] && echo "$errors"
596         return $exit_code
597 }
598
599 _daemon_set_ulimits() {
600         local opt val ksh=${KSH_VERSION:+1}
601         set -- ${SERVICE_LIMITS:-$DEFAULT_SERVICE_LIMITS}
602         while [ $# -gt 0 ]; do
603                 opt=$1
604                 val=$2
605                 if [ "$ksh" ]; then
606                         case "$opt" in
607                         -Hu)
608                                 opt=-Hp
609                         ;;
610                         -Su)
611                                 opt=-Sp
612                         ;;
613                         -u)
614                                 opt=-p
615                         ;;
616                         esac
617                 fi
618                 ulimit $opt $val
619                 shift 2
620         done
621 }
622
623 # A function to start a program (now it's useful on read-only filesystem too)
624 daemon() {
625         local errors="" prog="" end="" waitname="" waittime=""
626         local exit_code=0
627         local nice=$SERVICE_RUN_NICE_LEVEL
628         local fork user closefds redirfds pidfile makepid chdir=/
629
630         # NOTE: if you wonder how the shellish (by syntax) $prog works in ssd mode,
631         # then the answer is: it totally ignores $prog and uses "$@" itself.
632
633         while [ $# -gt 0 ]; do
634                 case $1 in
635                 '')
636                 msg_usage " daemon [--check] [--user user] [--fork] [--chdir directory] [--closefds] [--redirfds] [--waitforname procname] [--waitfortime seconds] [--pidfile file] [--makepid] [+/-nicelevel] {program} <program args>"
637                         return 2
638                         ;;
639                 --check)
640                         # for compatibility with redhat/mandrake
641                         nls "warning: --check option is ignored!"
642                         shift
643                         ;;
644                 --user)
645                         shift
646                         user=$1
647                         ;;
648                 --fork)
649                         fork=1
650                         end='&'
651                         ;;
652                 --chdir)
653                         shift
654                         chdir=$1
655                         ;;
656                 --closefds)
657                         closefds=1
658                         ;;
659                 --redirfds)
660                         redirfds=1
661                         ;;
662                 --waitforname)
663                         shift
664                         waitname="$1"
665                         ;;
666                 --waitfortime)
667                         shift
668                         waittime="$1"
669                         ;;
670                 --pidfile=?*)
671                         pidfile="${1#--pidfile=}"
672                         case "$pidfile" in /*);; *) pidfile="/var/run/$pidfile";; esac
673                         ;;
674                 --pidfile)
675                         shift
676                         pidfile="$1"
677                         case "$pidfile" in /*);; *) pidfile="/var/run/$pidfile";; esac
678                         ;;
679                 --makepid)
680                         makepid=1
681                         ;;
682                 -*|+*)
683                         nice=$1
684                         shift
685                         break
686                         ;;
687                 *)
688                         break
689                         ;;
690                 esac
691                 shift
692         done
693         if [ -n "$user" -a "$user" != "root" ]; then
694                 prog="/bin/su $user -s /bin/sh -c \""
695         fi
696         if [ "$fork" = "1" ]; then
697                 prog="/usr/bin/setsid ${prog:-sh -c \"}"
698         fi
699         # If command to execute ends with quotation mark, add remaining
700         # arguments and close quotation.
701         if [ "$prog" != "${prog%\"}" ]; then
702                 prog="$prog $*$end\""
703         else
704                 prog="$prog $*$end"
705         fi
706
707         _daemon_set_ulimits
708
709         [ -z "$DEFAULT_SERVICE_UMASK" ] && DEFAULT_SERVICE_UMASK=022
710         [ -z "$DEFAULT_SERVICE_RUN_NICE_LEVEL" ] && DEFAULT_SERVICE_RUN_NICE_LEVEL=0
711
712         # And start it up.
713         busy
714         cd $chdir
715         [ -n "$SERVICE_CPUSET" ] && is_yes "$CPUSETS" && echo $$ > "/dev/cpuset/${SERVICE_CPUSET}/tasks"
716         if errors=$(
717                 umask ${SERVICE_UMASK:-$DEFAULT_SERVICE_UMASK};
718                 export USER=root HOME=/tmp TMPDIR=/tmp
719
720                 nice=${nice:-$DEFAULT_SERVICE_RUN_NICE_LEVEL}
721                 nice=${nice:-0}
722
723                 # make nice level absolute, not to be dependant of nice level of shell where service started
724                 nice=$(($nice - $(nice)))
725
726                 if [ "$closefds" = 1 ]; then
727                         exec 1>&-
728                         exec 2>&-
729                         exec 0<&-
730                 elif [ "$redirfds" = 1 ]; then
731                         exec 1>/dev/null
732                         exec 2>/dev/null
733                         exec 0</dev/null
734                 else
735                         exec 2>&1
736                         exec 0</dev/null
737                 fi
738
739                 if is_no "$RC_LOGGING"; then
740                         prog=$1; shift
741                         if [ ! -x $prog ]; then
742                                 logger -t rc-scripts -p daemon.debug "daemon: Searching PATH for $prog, consider using full path in initscript"
743                                 local a o=$IFS
744                                 IFS=:
745                                 for a in $PATH; do
746                                         if [ -x $a/$prog ]; then
747                                                 prog=$a/$prog
748                                                 break
749                                         fi
750                                 done
751                                 IFS=$o
752                         fi
753                         set -- "$prog" "$@"
754
755                         /sbin/start-stop-daemon -q --start \
756                                 --nicelevel $nice \
757                                 ${pidfile:+--pidfile $pidfile} \
758                                 ${makepid:+--make-pidfile} \
759                                 ${user:+--chuid $user} \
760                                 ${chdir:+--chdir "$chdir"} \
761                                 ${fork:+--background} \
762                                 ${waitname:+--name $waitname} \
763                                 ${SERVICE_DROPCAPS:+--dropcap $SERVICE_DROPCAPS} \
764                                 --exec "$1" \
765                                 -- "$@"
766                 else
767                         nice -n $nice initlog -c "$prog" 2>&1 </dev/null
768                 fi
769                 ); then
770
771                 if [ -n "$waitname" -a -n "$waittime" ]; then
772                         # Save basename.
773                         base=${waitname##*/}
774                         # Find pid.
775                         pid=$(pidofproc "$waitname" "$pidfile")
776                         [ -z "$pid" ] && pid=$(pidofproc "$base" "$pidfile")
777                         i=0
778                         while [ "$i" -lt "$waittime" ]; do
779                                 i=$((i + 1))
780                                 checkpid $pid && sleep 1 || break
781                         done
782                 fi
783                 log_success "$1 startup"
784                 ok
785         else
786                 exit_code=1
787                 fail
788                 log_failed "$1 startup"
789                 [ -n "$errors" ] && echo >&2 "$errors"
790         fi
791         return $exit_code
792 }
793
794 # A function to stop a program.
795 killproc() {
796         local notset killlevel base pid pidfile result delay=3 try
797         # Test syntax.
798         if [ $# = 0 ]; then
799                 msg_usage " killproc [--pidfile|-p PIDFILE] [-d DELAY] {program} [-SIGNAME]"
800                 return 2
801         fi
802
803         while [ "$1" != "${1##-}" ]; do
804                 case $1 in
805                 -d)
806                         delay="$2"
807                         shift 2
808                         ;;
809                 --pidfile|-p)
810                         pidfile="$2"
811                         case "$pidfile" in /*);; *) pidfile="/var/run/$pidfile";; esac
812                         shift 2
813                         ;;
814                 --waitforname)
815                         waitname="$2"
816                         shift 2
817                         ;;
818                 --waitfortime)
819                         waittime="$2"
820                         shift 2
821                         ;;
822                 esac
823         done
824
825         busy
826
827         local notset=0
828         # check for second arg to be kill level
829         if [ -n "$2" ]; then
830                 killlevel=$2
831         else
832                 notset=1
833         fi
834
835         # experimental start-stop-daemon based killing.
836         # works only with pidfile
837         if is_no "$RC_LOGGING" && [ "$pidfile" ]; then
838                 local sig=${killlevel:--TERM} retry
839                 # retry only if signal is not specified,
840                 # as otherwise impossible to send HUP if process pid stays in pidfile.
841                 if [ "${killlevel+set}" = "set" ]; then
842                         # if we send HUP it's ok if process does not die
843                         retry="--oknodo"
844                 else
845                         retry="--retry ${sig#-}/10/${sig#-}/60/KILL/10"
846                 fi
847                 /sbin/start-stop-daemon -q --stop \
848                         $retry \
849                         -s ${sig#-} \
850                         ${pidfile:+--pidfile $pidfile}
851                 result=$?
852                 if [ "$result" -eq 0 ]; then
853                         ok
854                 else
855                         fail
856                 fi
857                 return $result
858         fi
859
860
861         # Save basename.
862         base=${1##*/}
863
864         # Find pid.
865         pid=$(pidofproc "$1" "$pidfile")
866         [ -z "$pid" ] && pid=$(pidofproc "$base" "$pidfile")
867
868         # Kill it.
869         if [ -n "$pid" -a "$pid" != "$$" ] && checkpid $pid 2>&1; then
870                 if [ "$notset" = "1" ]; then
871                         if checkpid $pid 2>&1; then
872                                 # TERM first, then KILL if not dead
873                                 kill -TERM $pid
874                                 usleep 50000
875
876                                 try=0
877                                 while [ $try -lt $delay ]; do
878                                         checkpid $pid || break
879                                         sleep 1
880                                         try=$((try+1))
881                                 done
882                                 if checkpid $pid; then
883                                         # XXX: SIGKILL is sent already on 4th second!
884                                         # HARMFUL for example to mysqld (which is already workarounded)
885                                         kill -KILL $pid
886                                         usleep 50000
887                                 fi
888                         fi
889                         checkpid $pid
890                         result=$?
891                         if [ "$result" -eq 0 ]; then
892                                 fail
893                                 log_failed "$1 shutdown"
894                         else
895                                 ok
896                                 log_success "$1 shutdown"
897                         fi
898                         result=$(( ! $result ))
899                 else
900                         # use specified level only
901                         if checkpid $pid > /dev/null 2>&1; then
902                                 kill $killlevel $pid
903                                 result=$?
904                                 if [ "$result" -eq 0 ]; then
905                                         ok
906                                         log_success "$1 got $killlevel"
907                                 else
908                                         result=7
909                                         fail
910                                         log_failed "$1 didn't get $killlevel"
911                                 fi
912                         else
913                                 result=7
914                                 died
915                                 log_failed "$1 shutdown"
916                         fi
917                 fi
918         else
919                 died
920                 log_failed "$1 shutdown"
921                 result=7
922         fi
923
924         if [ -n "$waitname" -a -n "$waittime" ]; then
925                 # Save basename.
926                 base=${waitname##*/}
927                 # Find pid.
928                 pid=$(pidofproc "$waitname" "$pidfile")
929                 [ -z "$pid" ] && pid=$(pidofproc "$base" "$pidfile")
930                 i=0
931                 while [ "$i" -lt "$waittime" ]; do
932                         i=$(( i + 1 ))
933                         checkpid $pid && sleep 1 || break
934                 done
935         fi
936
937         # Remove pid file if any.
938         if [ "$notset" = "1" ]; then
939                 rm -f /var/run/${base}.pid
940         fi
941
942         return $result
943 }
944
945 # A function to find the pid of a program.
946 pidofproc() {
947         local pid pidfile base=${1##*/}
948         pidfile="$base.pid"
949         [ -n "$2" ] && pidfile="$2"
950
951         # Test syntax.
952         if [ $# = 0 ]; then
953                 msg_usage " pidofproc {program}"
954                 return 2
955         fi
956
957         # First try pidfile or "/var/run/*.pid"
958         case "$pidfile" in
959                 /*)pidfile="${pidfile}";;
960                 *) pidfile="/var/run/$pidfile";;
961         esac
962         if [ -f "${pidfile}" ]; then
963                 local p pid=""
964                 for p in $(< "${pidfile}"); do
965                         [ -z "$(echo "$p" | awk '{gsub(/[0-9]/,"");print;}')" ] && pid="$pid $p"
966                 done
967         fi
968
969         # Next try "pidof"
970         [ -z "$pid" ] && pidof -o $$ -o $PPID -o %PPID -x "$1"
971         pid=$(filter_chroot $pid)
972         echo $pid
973 }
974
975 # status [--pidfile PIDFILE] {subsys} [{daemon}]"
976 status() {
977         local pid subsys daemon cpuset_msg pidfile
978         if [ "$1" = "--pidfile" -o "$1" = "-p" ]; then
979                 pidfile=$2
980                 case "$pidfile" in /*);; *) pidfile="/var/run/$pidfile";; esac
981                 shift 2
982         fi
983
984         subsys=$1
985         daemon=${2:-$subsys}
986
987         # Test syntax.
988         if [ $# = 0 ]; then
989                 msg_usage " status [--pidfile PIDFILE] {subsys} [{daemon}]"
990                 return 2
991         fi
992
993         # if pidfile specified, pid must be there
994         if [ "$pidfile" ]; then
995                 [ -f "$pidfile" ] && read pid < $pidfile
996                 # filter_chroot does not filter out dead pids, so this extra check, see t/status-pidfile.sh
997                 if [ ! -d "/proc/$pid" ]; then
998                         pid=
999                 fi
1000         else
1001                 pid=$(pidof -o $$ -o $PPID -o %PPID -x $daemon)
1002         fi
1003         pid=$(filter_chroot $pid)
1004
1005         if [ "$pid" ]; then
1006                 cpuset_msg="..."
1007                 if [ -n "$SERVICE_CPUSET" ] && is_yes "$CPUSETS"; then
1008                         if grep -q "$pid" "/dev/cpuset/${SERVICE_CPUSET}/tasks"; then
1009                                 cpuset_msg=$(nls " in cpuset %s..." "$SERVICE_CPUSET")
1010                         else
1011                                 cpuset_msg=$(nls " outside of configured cpuset %s..." "$SERVICE_CPUSET")
1012                         fi
1013                 fi
1014                 nls "%s (pid %s) is running%s" "$daemon" "$pid" "$cpuset_msg"
1015                 return 0
1016         fi
1017
1018         # Next try "/var/run/*.pid" files; if pidfile is not set
1019         local base=${daemon##*/}
1020         if [ -z "$pidfile" -a -f /var/run/${base}.pid ]; then
1021                 read pid < /var/run/${base}.pid
1022                 pid=$(filter_chroot $pid)
1023                 if [ "$pid" ]; then
1024                         nls "%s dead but pid file (%s) exists" "$subsys" /var/run/${base}.pid
1025                         return 1
1026                 fi
1027         fi
1028
1029         # See if /var/lock/subsys/$subsys exists
1030         if [ -f /var/lock/subsys/$subsys ]; then
1031                 nls "daemon %s dead but subsys (%s) locked" "$daemon" "$subsys"
1032                 return 2
1033         fi
1034         nls "%s is stopped" "$subsys"
1035         return 3
1036 }
1037
1038 # Confirm whether we really want to run this service
1039 confirm() {
1040         local answer
1041         nls -n "Start service %s (Y)es/(N)o/(C)ontinue? [Y] " "$1"
1042         read answer
1043         case $answer in
1044         y|Y|t|T|j|J|"")
1045                 return 0
1046                 ;;
1047         c|C|k|K|w|W)
1048                 return 2
1049                 ;;
1050         n|N)
1051                 return 1
1052                 ;;
1053         *)
1054                 confirm $1
1055                 return $?
1056                 ;;
1057         esac
1058 }
1059
1060 # module is needed (ie. is requested, is available and isn't loaded already)
1061 is_module() {
1062         # module name without .o at end
1063         if ! lsmod | grep -q "$1"; then
1064                 if ls -1R /lib/modules/$(uname -r)/ 2> /dev/null | grep -q "^${1}.\(\|k\)o\(\|.gz\)"; then
1065                         # true
1066                         return 0
1067                 fi
1068         fi
1069         # false
1070         return 1
1071 }
1072
1073 _modprobe() {
1074         local parsed single die args foo result
1075         parsed=no
1076         while is_no "$parsed"; do
1077                 case "$1" in
1078                 "single")
1079                         single=yes
1080                         shift
1081                         ;;
1082                 "die")
1083                         die=yes
1084                         shift
1085                         ;;
1086                 -*)
1087                         args="$args $1"
1088                         shift
1089                         ;;
1090                 *)
1091                         parsed=yes
1092                         ;;
1093                 esac
1094         done
1095         if is_yes "${single}"; then
1096                 foo="$@"
1097                 show "Loading %s kernel module(s)" "$foo"
1098                 busy
1099         fi
1100         if [ -x /sbin/modprobe ]; then
1101                 /sbin/modprobe -s $args "$@"
1102                 result=$?
1103         else
1104                 deltext; fail
1105                 result=1
1106         fi
1107         if is_yes "${single}"; then
1108                 deltext
1109                 if [ $result = "0" ]; then
1110                         is_yes "$single" && ok
1111                 else
1112                         fail
1113                         if is_yes "$die"; then
1114                                 nls "Could not load %s kernel module(s)" "$@"
1115                                 exit 1
1116                         fi
1117                 fi
1118         fi
1119 }
1120
1121 if is_no "$RC_LOGGING"; then
1122         log_success() {
1123                 :
1124         }
1125
1126         log_failed() {
1127                 :
1128         }
1129 else
1130         log_success() {
1131                 initlog -n $0 -s "$1 $2" -e 1
1132         }
1133
1134         log_failed() {
1135                 initlog -n $0 -s "$1 $2" -e 2
1136         }
1137 fi
1138
1139 # Check if any flavor of portmapper is running
1140 check_portmapper() {
1141         if [ -x /usr/sbin/rpcinfo ]; then
1142                 if /usr/sbin/rpcinfo -p localhost >/dev/null 2>/dev/null; then
1143                         return 0
1144                 else
1145                         return 1
1146                 fi
1147         elif [ -z "$(pidof portmap)" -a -z "$(pidof rpcbind)" ]; then
1148                 return 1
1149         fi
1150         return 0
1151 }
1152
1153 # is_fsmounted fstype mntpoint
1154 # Check if filesystem fstype is mounted on mntpoint
1155 is_fsmounted() {
1156         local fstype=$1
1157         local mntpoint=$2
1158
1159         [ -n "$fstype" -a -n "$mntpoint" ] || return 1
1160
1161         if [ -r /proc/mounts ]; then
1162                 grep -qE "[[:blank:]]$mntpoint[[:blank:]]+$fstype[[:blank:]]" /proc/mounts
1163                 return $?
1164         else
1165                 if [ "$(stat -L -f -c %T $mntpoint 2>/dev/null)" = "$fstype" ]; then
1166                         return 0
1167                 else
1168                         return 1
1169                 fi
1170         fi
1171 }
1172
1173 # __umount_loop awk_program fstab_file first_msg retry_msg umount_args
1174 # awk_program should process fstab_file and return a list of fstab-encoded
1175 # paths; it doesn't have to handle comments in fstab_file.
1176 __umount_loop() {
1177         local remaining sig=
1178         local retry=3 count
1179
1180         remaining=$(LC_ALL=C awk "/^#/ {next} $1" "$2" | sort -r)
1181         while [ -n "$remaining" -a "$retry" -gt 0 ]; do
1182                 if [ "$retry" -eq 3 ]; then
1183                         run_cmd "$3" fstab-decode umount $5 $remaining
1184                 else
1185                         run_cmd "$4" fstab-decode umount $5 $remaining
1186                 fi
1187                 count=4
1188                 remaining=$(LC_ALL=C awk "/^#/ {next} $1" "$2" | sort -r)
1189                 while [ "$count" -gt 0 ]; do
1190                         [ -z "$remaining" ] && break
1191                         count=$(($count-1))
1192                         usleep 500000
1193                         remaining=$(LC_ALL=C awk "/^#/ {next} $1" "$2" | sort -r)
1194                 done
1195                 [ -z "$remaining" ] && break
1196                 fstab-decode /bin/fuser -k -m $sig $remaining >/dev/null
1197                 sleep 3
1198                 retry=$(($retry -1))
1199                 sig=-9
1200         done
1201 }
1202
1203 # Similar to __umount loop above, specialized for loopback devices
1204 __umount_loopback_loop() {
1205         local remaining devremaining sig=
1206         local retry=3
1207
1208         remaining=$(awk '$1 ~ /^\/dev\/loop/ && $2 != "/" {print $2}' /proc/mounts)
1209         devremaining=$(awk '$1 ~ /^\/dev\/loop/ && $2 != "/" {print $1}' /proc/mounts)
1210         while [ -n "$remaining" -a "$retry" -gt 0 ]; do
1211                 if [ "$retry" -eq 3 ]; then
1212                         run_cmd "Unmounting loopback filesystems: " \
1213                                 fstab-decode umount $remaining
1214                 else
1215                         run_cmd "Unmounting loopback filesystems (retry):" \
1216                                 fstab-decode umount $remaining
1217                 fi
1218                 for dev in $devremaining ; do
1219                         losetup $dev > /dev/null 2>&1 && \
1220                                 run_cmd "Detaching loopback device $dev: " \
1221                                 losetup -d $dev
1222                 done
1223                 remaining=$(awk '$1 ~ /^\/dev\/loop/ && $2 != "/" {print $2}' /proc/mounts)
1224                 devremaining=$(awk '$1 ~ /^\/dev\/loop/ && $2 != "/" {print $1}' /proc/mounts)
1225                 [ -z "$remaining" ] && break
1226                 fstab-decode /bin/fuser -k -m $sig $remaining >/dev/null
1227                 sleep 3
1228                 retry=$(($retry -1))
1229                 sig=-9
1230         done
1231 }
1232
1233 rc_cache_init() {
1234         # If we have cachefile, use it.
1235         # If we don't, create memory variables and try to save silently,
1236         local cachefile='/var/cache/rc-scripts/msg.cache'
1237
1238         local term
1239         if is_yes "$ISATTY"; then
1240                 term=$TERM
1241         else
1242                 term=dumb
1243         fi
1244
1245         # We create $check variable which is used to invalidate the cache.
1246         # The $check contains user locale and terminal.
1247         local check="$term.$LC_MESSAGES.$INIT_COL"
1248
1249         if [ -f "$cachefile" -a "$cachefile" -nt /etc/sysconfig/system -a "$cachefile" -nt /etc/sysconfig/init-colors ]; then
1250                 if . "$cachefile" 2>/dev/null; then
1251                         if [ "$check" = "$_check" ]; then
1252                                 return
1253                         fi
1254                 fi
1255         fi
1256
1257         # primitive caching
1258         _busy=$(progress "BUSY" "$CBUSY")
1259         _ok=$(progress "DONE")
1260         _started=$(progress "WORK")
1261         _fail=$(progress "FAIL" "$CFAIL")
1262         _died=$(progress "DIED" "$CFAIL")
1263
1264         # we don't use heredoc, as ksh attempts to create tempfile then
1265         (> "$cachefile" ) 2>/dev/null || return
1266         echo "_busy='$_busy';" >> "$cachefile"
1267         echo "_ok='$_ok';" >> "$cachefile"
1268         echo "_started='$_started';" >> "$cachefile"
1269         echo "_fail='$_fail';" >> "$cachefile"
1270         echo "_died='$_died';" >> "$cachefile"
1271         echo "_check='$check';" >> "$cachefile"
1272 }
1273
1274 rc_gettext_init() {
1275         if [ -z "$GETTEXT" ]; then
1276                 if [ -x /bin/gettext -o -x /usr/bin/gettext ]; then
1277                         GETTEXT=yes
1278                 else
1279                         GETTEXT=no
1280                 fi
1281         fi
1282
1283         if [ -z "$TPUT" ]; then
1284                 if [ -d /usr/share/terminfo ] && [ -x /usr/bin/tput -o -x /bin/tput ]; then
1285                         TPUT=yes
1286                         # check if we are on proper terminal
1287                         tput longname >/dev/null 2>&1 || TPUT=no
1288                 else
1289                         TPUT=no
1290                 fi
1291         fi
1292 }
1293
1294 use_upstart () {
1295         # True when upstart-event-based boot should be used
1296         is_yes "$USE_UPSTART" && return 0
1297         is_no "$USE_UPSTART" && return 1
1298         if [ ! -x /sbin/initctl ] ; then
1299                 USE_UPSTART="no"
1300                 return 1
1301         fi
1302         local cmdline=$(cat /proc/cmdline 2>/dev/null)
1303         if strstr "$cmdline" "pld.no-upstart" ; then
1304                 USE_UPSTART="no"
1305                 return 1
1306         else
1307                 USE_UPSTART="yes"
1308                 return 0
1309         fi
1310 }
1311
1312 emit () {
1313         # emit upstart signal
1314         # only when 'upstart' boot is enabled
1315         use_upstart || return 0
1316         /sbin/initctl emit "$@"
1317 }
1318
1319 is_upstart_task() {
1320         # Return 0 if the given service is an upstart task.
1321         grep -q '^task' "/etc/init/$1.conf"
1322 }
1323 is_upstart_running() {
1324         # Return 0 if the given service is running via upstart
1325         initctl status "$1" 2>/dev/null | grep -q running
1326 }
1327 upstart_start() {
1328         local service=$1
1329         if is_upstart_running "${service}"; then
1330                 msg_already_running "$service"
1331                 return 0
1332         fi
1333
1334         msg_starting "${service}"
1335         if errors=$(/sbin/initctl start ${service} 2>&1) ; then
1336                 ok
1337                 return 0
1338         else
1339                 fail
1340                 echo "$errors" >&2
1341                 return 1
1342         fi
1343 }
1344 upstart_stop() {
1345         local service=$1
1346         if ! is_upstart_running "${service}"; then
1347                 msg_not_running "$name"
1348                 return 0
1349         fi
1350         msg_stopping "${service}"
1351         if errors=$(/sbin/initctl stop ${service}) ; then
1352                 ok
1353                 return 0
1354         else
1355                 fail
1356                 echo "$errors" >&2
1357                 return 1
1358         fi
1359 }
1360 upstart_reload() {
1361         local service=$1
1362         if ! is_upstart_running "${service}" && ! is_upstart_task "${service}" ; then
1363                 return 0
1364         fi
1365         msg_reloading "${service}"
1366         if errors=$(/sbin/initctl reload ${service}) ; then
1367                 ok
1368                 return 0
1369         else
1370                 fail
1371                 echo "$errors" >&2
1372                 return 1
1373         fi
1374 }
1375 upstart_status() {
1376         # get service status
1377         # should be compliant with
1378         # http://refspecs.freestandards.org/LSB_3.1.1/LSB-Core-generic/LSB-Core-generic/iniscrptact.html
1379         local service=$1
1380         local status
1381         if is_upstart_task "${service}" ; then
1382                 # we probably should have a way to handle task status
1383                 return 0
1384         fi
1385         if ! status=$(/sbin/initctl status "${service}") ; then
1386                 # program or service status is not known
1387                 return 4
1388         fi
1389         if strstr "$status" "running" ; then
1390                 # program is running or service is OK
1391                 echo "$status"
1392                 return 0
1393         else
1394                 # program is not running
1395                 echo "$status"
1396                 return 3
1397         fi
1398         # TODO: other statuses
1399 }
1400
1401 _upstart_controlled() {
1402         # If the service is to be handled by upstart
1403         # execute the start/stop/etc. commands the upstart way
1404         if ! use_upstart; then
1405                 return 0
1406         fi
1407         local script=$1
1408         shift
1409         local command=$1
1410         [ $# -gt 0 ] && shift
1411         local name=$(basename "$script")
1412         if [ ! -f /etc/init/${name}.conf ] ; then
1413                 return 0
1414         fi
1415         local commands
1416         local extra_commands
1417         local has_configtest
1418         if [ "$1" = "--except" ] ; then
1419                 shift
1420                 commands="$*"
1421                 for cmd in $commands ; do
1422                         if [ "$command" = "$cmd" ] ; then
1423                                 return 0
1424                         fi
1425                         case "$cmd" in
1426                                 start|stop|status|reload|restart|try-restart|force-reload)
1427                                         ;;
1428                                 configtest)
1429                                         has_configtest=yes
1430                                         extra_commands="|$cmd"
1431                                         ;;
1432                                 *)
1433                                         extra_commands="|$cmd"
1434                                         ;;
1435                         esac
1436                 done
1437         elif [ -n "$*" ] ; then
1438                 commands="$*"
1439                 local cmd
1440                 local found=0
1441                 # is there a better way
1442                 for cmd in $commands ; do
1443                         if [ "$command" = "$cmd" ] ; then
1444                                 found=1
1445                                 break;
1446                         fi
1447                 done
1448                 if [ $found = 0 ] ; then
1449                         # let the script handle it
1450                         return 0
1451                 fi
1452         fi
1453         case "$command" in
1454                 start)
1455                         upstart_start $name
1456                         exit $?
1457                         ;;
1458                 stop)
1459                         upstart_stop $name
1460                         exit $?
1461                         ;;
1462                 status)
1463                         upstart_status $name
1464                         exit $?
1465                         ;;
1466                 restart)
1467                         if is_yes "$has_configtest" ; then
1468                                 "$script" configtest || exit 1
1469                         fi
1470                         upstart_stop $name
1471                         upstart_start $name
1472                         exit $?
1473                         ;;
1474                 try-restart)
1475                         if ! is_upstart_running "$name" ; then
1476                                 exit 0
1477                         fi
1478                         if is_yes "$has_configtest" ; then
1479                                 "$script" configtest || exit 1
1480                         fi
1481                         upstart_stop $name
1482                         upstart_start $name
1483                         exit $?
1484                         ;;
1485                 reload)
1486                         if is_yes "$has_configtest" ; then
1487                                 "$script" configtest || exit 1
1488                         fi
1489                         if is_upstart_task "$name" ; then
1490                                 nls "$command not implemented for $name"
1491                                 exit 3
1492                         else
1493                                 upstart_reload "$name"
1494                                 exit $?
1495                         fi
1496                         ;;
1497                 force-reload)
1498                         if is_yes "$has_configtest" ; then
1499                                 "$script" configtest || exit 1
1500                         fi
1501                         if is_upstart_task "$name" ; then
1502                                 upstart_stop "$name"
1503                                 upstart_start "$name"
1504                                 exit $?
1505                         else
1506                                 upstart_reload "$name"
1507                                 exit $?
1508                         fi
1509                         ;;
1510                 *)
1511                         msg_usage "$0 {start|stop|restart|reload|force-reload|status$extra_commands}"
1512                         exit 3
1513                         ;;
1514         esac
1515         return 1 # should not happen
1516 }
1517
1518 # Usage:
1519 #       somewhere at the begining of init script:
1520 #     upstart_controlled
1521 #               - to pass implement all upstart commands via initctl
1522 #                 start, stop, status, restart, reload and force_reload
1523 #                 are implemented
1524 #     upstart_controlled command...
1525 #               - to pass handle only specific commands the upstart way
1526 #                 and leave the rest to the script
1527 #
1528 alias upstart_controlled='_upstart_controlled $0 "$@"'
1529
1530 rc_gettext_init
1531 rc_cache_init
1532
1533 #/*
1534 # * Local variables:
1535 # * mode: sh
1536 # * indent-tabs-mode: notnil
1537 # * End:
1538 # *
1539 # */
This page took 0.177691 seconds and 4 git commands to generate.